-- ASTEROID FUNCTIONS --
local asteroidController = require "asteroid"

function asteroidController:spawn(amount)
    for i=1,amount do
        asteroid = {}
        --random  position within screen for now
        asteroid.x = math.random(width)
        asteroid.y = math.random(height)
        asteroid.size = math.random(10, 30)
        asteroid.sides = math.random(3, 8)
        
        asteroid.xMoment = math.random(-75, 75) / 75.0
        asteroid.yMoment = math.random(-75, 75) / 75.0
        
        asteroid.rot = 0
        asteroid.rotMoment = math.random(10, 60) / 10.0
        asteroid.xRot = (math.cos(asteroid.rot * math.pi / 360))
        asteroid.yRot = (math.sin(asteroid.rot * math.pi / 360))
        
        table.insert(asteroidController.asteroids, asteroid)
    end
end
    
function asteroidController:drawAsteroids()
    for _,a in pairs(asteroidController.asteroids) do
        love.graphics.push()
        love.graphics.translate(a.x, a.y)
        love.graphics.rotate((a.rot-180) * math.pi / 360)
        love.graphics.translate(-a.x, -a.y)
        love.graphics.circle("line", a.x, a.y, a.size, a.sides)
        love.graphics.pop()
    end
end

function asteroidController:moveAsteroids()
    for _,a in pairs(asteroidController.asteroids) do
        a.x = a.x + a.xMoment
        a.y = a.y + a.yMoment
        
        a.rot = a.rot + a.rotMoment
        
        --world wrapping
        if a.x < -5 then
            a.x = width+5
        
        elseif a.x > width+5 then
            a.x = -5
        end
        
        if a.y < -5 then
            a.y = height+5
        
        elseif a.y > height+5 then
            a.y = -5
        end
    end
end

return asteroidController