local player = require "playerFunctions"
local asteroidController = require "asteroidFunctions"
local core = require "functions"


function love.load()
    math.randomseed(os.time())
    love.window.setMode(1280, 720, {fullscreen=false})
    love.graphics.setColor(255,255,255)
    
    _G.width, _G.height = love.window.getMode()
    
    player.makePlayer()
    asteroidController.spawn(nil, 10)
    

end

function love.update(dt)
    --player control
    core.updateCounters()
    core.getInput(dt)
    
    --player movement
    player.movePlayer()
    
    --asteroid movement
    asteroidController.moveAsteroids()
    
    --bullet movement
    core.moveBullets(dt)
    
    --collision
    core.collision()
end

function love.draw()
    if player.lives > 0 then
        if #asteroidController.asteroids == 0 then
            love.graphics.setColor(0,255,0)
            love.graphics.print("You Won! \n R to reset", width/2, height/2)
        end
        player.drawShip()
    else
        love.graphics.setColor(255,0,0)
        love.graphics.print("Game Over \n R to reset", width/2, height/2)
    end
    
    core.drawBullets()
    asteroidController.drawAsteroids()
end