-- PLAYER FUNCTIONS --
local player = require "player"


function player:makePlayer()
    player.x = width/2
    player.y = height/2
end

function player:drawShip()
    love.graphics.push()
    love.graphics.translate(player.x, player.y)
    love.graphics.rotate((player.rot-180) * math.pi / 360)
    love.graphics.translate(-player.x, -player.y)
    love.graphics.polygon("line", player.x-6, player.y-6, player.x, player.y+16, player.x+6, player.y-6)
    love.graphics.pop()
    
    love.graphics.points(player.x, player.y)
end

function player:movePlayer()
    --update player position and rotation
    player.rot = player.rot + player.rotMoment
    player.x = player.x + player.xMoment
    player.y = player.y + player.yMoment
    
    --world wrapping
    if player.x < -2 then
        player.x = width
    
    elseif player.x > width+2 then
        player.x = 0
    end
    
    if player.y < -2 then
        player.y = height
    
    elseif player.y > height+2 then
        player.y = 0
    end
end

function player:faster()
    player.xMoment = player.xMoment + player.speed * player.xRot
    player.yMoment = player.yMoment + player.speed * player.yRot
end

function player:slower()
    player.xMoment = player.xMoment - player.speed * player.xRot
    player.yMoment = player.yMoment - player.speed * player.yRot
end

function player:brake()
    player.xMoment = player.xMoment * 0.98
    player.yMoment = player.yMoment * 0.98
    player.rotMoment = player.rotMoment * 0.96
end

function player:fire()
    player.bulletCooldown = 0
    
    --bullet pushback
    player.xMoment = player.xMoment - player.bulletMass * player.xRot
    player.yMoment = player.yMoment - player.bulletMass * player.yRot
    
    bullet = {}
    bullet.x = player.x + (player.speed * player.xRot)
    bullet.y = player.y + (player.speed * player.yRot)
    bullet.xMoment = player.xMoment + (player.bulletSpeed * player.xRot)
    bullet.yMoment = player.yMoment + (player.bulletSpeed * player.yRot)
    bullet.age = 0
    table.insert(player.bullets, bullet)
end

return player